package com.example.haiwei_mom.wms.product;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;
import androidx.databinding.ObservableInt;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.util.Log;
import android.view.View;

import com.example.haiwei_mom.R;
import com.example.haiwei_mom.adapter.BindVehicleAdapter;
import com.example.haiwei_mom.adapter.ItemClickCall;
import com.example.haiwei_mom.base.BaseActivity;
import com.example.haiwei_mom.base.MyRecultCall;
import com.example.haiwei_mom.base.MyResult;
import com.example.haiwei_mom.databinding.ActivityBindVehicleBinding;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.Response;

import java.util.ArrayList;
import java.util.List;

public class BindVehicleActivity extends BaseActivity implements ItemClickCall {
    private ActivityBindVehicleBinding binding;
    private ArrayList<String> list;
    private BindVehicleAdapter adapter;
    private ObservableInt listSize;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_bind_vehicle);
        list = new ArrayList<>();
        listSize = new ObservableInt();
        binding.setSize(listSize);
        adapter = new BindVehicleAdapter(this, this);
        adapter.setList(list);
        binding.setAdapter(adapter);

    }

    @SuppressLint("NotifyDataSetChanged")
    @Override
    public void getScannerData(String data) {
        super.getScannerData(data);
        var text = binding.bindVehicleCode.getText().toString();
        if (text.isEmpty()) {
            binding.bindVehicleCode.setText(data);
            return;
        }
        if (list.contains(data)) {
            return;
        }
        Log.e("TAG", "getScannerData:" + listSize.get());
        list.add(data);
        adapter.notifyDataSetChanged();
        listSize.set(list.size());
    }

    @SuppressLint("NotifyDataSetChanged")
    @Override
    public void onClick(int position) {
        list.remove(position);
        adapter.notifyDataSetChanged();
        listSize.set(list.size());
    }

    public void bindVehicleSubmit(View view) {
        OkGo.<MyResult>post(url + "/wms/pda/product/bindVehicleSubmit")
                .params("vehicleCode", binding.bindVehicleCode.getText().toString())
                .addUrlParams("productList", list)
                .execute(new MyRecultCall(dialog, this) {
                    @Override
                    public void onSuccess(Response<MyResult> response) {
                        super.onSuccess(response);
                        var body = response.body();
                        if (body.getCode() == 200) {
                            finish();
                            return;
                        }
                        myToastUitls.show(body.getMsg());
                    }
                });
    }
}